#include "aimtrans.h"

/* Thanks to the gaim dudes for this func */
char *strip_html(char * text,pool p)
{
	int i, j;
	int visible = 1;
	char *text2 = pmalloc(p, strlen(text) + 1);
	
    if(text == NULL)
        return NULL;

	strcpy(text2, text);
	for (i = 0, j = 0;text2[i]; i++)
	{
		if(text2[i]=='<')
		{	
			visible = 0;
			continue;
		}
		else if(text2[i]=='>')
		{
			visible = 1;
			continue;
		}
		if(visible)
		{
			text2[j++] = text2[i];
		}
	}
	text2[j] = '\0';
	return text2;
}

char *str_to_UTF8(pool p,unsigned char *in)
{
    int n,i=0;
    char *result = NULL;
    /* for now, allocate more than enough space... */
    if(in==NULL) return NULL;
    result = (char*)pmalloc(p,strlen(in)*2+1);
    for(n=0;n<strlen(in);n++)
    {
        char *font;
        long c=(long)in[n];
        /*check for <font ....> html codes*/
        font=strstr(&in[n],"<font ");
        if(strlen(&in[n])>7&&strncasecmp(&in[n],"<font ",6)==0)
        {
            font=strchr(font,'>');
            if(font!=NULL)
            {
                n=((long)font)-((long)in);
                continue;
            }
        }
        /*strip out color codes*/
        if(c==27)
        {  
            n+=2;
            if(in[n]=='x')
                n++;
            if(in[n]=='3')
                n++;
            n++;
            continue;
        }
        if(c==0x0D||c==0x0a)
            continue;
        if(c<128)
        {
            result[i++]=(char)c;
        }
        else
        {
            result[i++]=(char)((c>>6)|192);
            result[i++]=(char)((c&63)|128);
        }
    }
    result[i]='\0';
    return result;
}

unsigned char *UTF8_to_str(pool p,unsigned char *in)
{
    int n,i;
    unsigned char *result = NULL;
    if(in==NULL) return NULL;
    result=(unsigned char*)pmalloc(p,strlen(in));
    n = 0;
    i = 0;
    while(n<=strlen(in)-1)
    {
       long c=(long)in[n];
       if(c<0x80)
           result[i++]=(char)c;
       else
       {
           if((c&0xC0)==0xC0)
               result[i++]=(char)(((c&0x03)<<6)|(((long)in[++n])&0x3F));
           else if((c&0xE0)==0xE0)
               result[i++]=(char)(((c&0xF)<<4)|(((long)in[++n])&0x3F)|(((long)in[++n])&0x3F)); 
           else if((c&0xF0)==0xF0)
               n+=3;
           else if((c&0xF8)==0xF8)
               n+=4;
           else if((c&0xFC)==0xFC)
               n+=5;
        }
        n++;
    }
        result[i]='\0';
        return result;
}

char *at_normalize(char *s)
{
    char *new, *old;

    if(s == NULL)
        return;

    log_debug(ZONE,"normalizing %s",s);

    new = old = s;
    while(*old)
    {
        if(*old == ' ')
        {
            old++;
            continue;
        }
        *new++ = *old++;
    }
    *new = '\0';

    log_debug(ZONE,"normalized %s",s);
    return s;
}

int at_xdb_set(ati ti, char *host, jid owner, xmlnode data, char *ns)
{
    xmlnode x = xmlnode_wrap(data, "aimtrans");
    int ret;
    jid j;
    char *res;

    res = owner->resource;
    jid_set(owner, NULL, JID_RESOURCE);

    log_debug(ZONE,"[AT] Setting XDB for user %s", jid_full(owner));

    j = jid_new(owner->p, spools(owner->p, shahash(jid_full(owner)), 
                "@", host, owner->p));
    ret = xdb_set(ti->xc, j, ns, x);

    jid_set(owner, res, JID_RESOURCE);

    return ret;
}

xmlnode at_xdb_get(ati ti, jid owner, char *ns)
{
    xmlnode x;
    jid j;
    char *res;

    log_debug(ZONE, "[AT] Getting XDB for user %s",jid_full(owner));
    
    res = owner->resource;
    jid_set(owner, NULL, JID_RESOURCE);

    j = jid_new(owner->p, spools(owner->p, shahash(jid_full(owner)), 
                "@", ti->i->id, owner->p));
    x= xdb_get(ti->xc, j, ns);

    jid_set(owner, res, JID_RESOURCE);

    return xmlnode_get_firstchild(x);
}

void at_psend(pth_msgport_t mp, jpacket p)
{
    static pth_msgport_t unknown_mp = NULL;
    jpq q;

    if(p == NULL || mp == NULL)
        return;

    log_debug(ZONE,"psending to %X packet %X",mp,p);

    q = pmalloc(p->p, sizeof(_jpq));
    q->p = p;

    q->head.m_replyport = unknown_mp;
    pth_msgport_put(mp, (pth_message_t *)q);
}
